#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire800eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 800"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight8004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight8004xi = {
                1:'-100x-787y-95z',
                2:'-108x-276y-742z',
                3:'-109x-163y-775z',
                4:'-111x-538y-580z',
                5:'-122x-163y-773z',
                6:'-123x-614y-496z',
                7:'-126x-277y-739z',
                8:'-135x-162y-771z',
                9:'-141x-537y-575z',
                10:'-141x-782y-87z',
                11:'-143x-277y-736z',
                12:'-149x-160y-769z',
                13:'-156x-612y-490z',
                14:'-15x-124y-790z',
                15:'-161x-275y-733z',
                16:'-163x-158y-767z',
                17:'-170x-534y-569z',
                18:'-176x-154y-764z',
                19:'-17x-791y-111z',
                20:'-180x-272y-730z',
                21:'-182x-774y-79z',
                22:'-189x-607y-484z',
                23:'-190x-149y-762z',
                24:'-198x-268y-726z',
                25:'-1x-110y-792z',
                26:'-200x-530y-564z',
                27:'-204x-143y-759z',
                28:'-216x-263y-723z',
                29:'-218x-137y-757z',
                30:'-223x-601y-477z',
                31:'-223x-764y-71z',
                32:'-22x-131y-788z',
                33:'-230x-524y-558z',
                34:'-231x-129y-754z',
                35:'-235x-257y-720z',
                36:'-244x-120y-752z',
                37:'-253x-249y-716z',
                38:'-256x-593y-471z',
                39:'-257x-110y-749z',
                40:'-259x-516y-552z',
                41:'-25x-531y-597z',
                42:'-25x-611y-515z',
                43:'-263x-752y-63z',
                44:'-270x-99y-746z',
                45:'-271x-240y-712z',
                46:'-282x-86y-743z',
                47:'-289x-230y-709z',
                48:'-289x-507y-546z',
                49:'-289x-583y-464z',
                50:'-293x-73y-740z',
                51:'-302x-738y-55z',
                52:'-304x-59y-737z',
                53:'-306x-219y-705z',
                54:'-314x-44y-734z',
                55:'-318x-495y-541z',
                56:'-31x-138y-787z',
                57:'-321x-571y-458z',
                58:'-323x-206y-701z',
                59:'-323x-29y-731z',
                60:'-32x-290y-851z',
                61:'-340x-193y-697z',
                62:'-340x-722y-47z',
                63:'-346x-482y-535z',
                64:'-353x-557y-451z',
                65:'-356x-178y-693z',
                66:'-371x-162y-689z',
                67:'-375x-468y-529z',
                68:'-378x-703y-39z',
                69:'-384x-542y-444z',
                70:'-385x-144y-685z',
                71:'-399x-126y-681z',
                72:'-402x-451y-523z',
                73:'-40x-143y-785z',
                74:'-411x-107y-677z',
                75:'-414x-683y-31z',
                76:'-415x-524y-438z',
                77:'-429x-433y-517z',
                78:'-43x-263y-753z',
                79:'-445x-505y-431z',
                80:'-450x-660y-23z',
                81:'-455x-414y-510z',
                82:'-473x-484y-424z',
                83:'-480x-393y-504z',
                84:'-484x-636y-15z',
                85:'-501x-462y-418z',
                86:'-504x-370y-498z',
                87:'-50x-148y-784z',
                88:'-516x-610y-7z',
                89:'-527x-346y-492z',
                90:'-528x-437y-411z',
                91:'-53x-535y-591z',
                92:'-548x-320y-485z',
                93:'-548x-582y0z',
                94:'-553x-412y-404z',
                95:'-569x-293y-479z',
                96:'-577x-384y-397z',
                97:'-57x-614y-509z',
                98:'-587x-265y-473z',
                99:'-58x-791y-103z',
                100:'-59x-268y-751z',
                101:'-600x-355y-390z',
                102:'-605x-236y-466z',
                103:'-61x-153y-782z',
                104:'-621x-205y-460z',
                105:'-621x-325y-383z',
                106:'-635x-173y-453z',
                107:'-641x-294y-376z',
                108:'-648x-141y-446z',
                109:'-659x-107y-440z',
                110:'-659x-261y-369z',
                111:'-668x-73y-433z',
                112:'-675x-228y-362z',
                113:'-690x-193y-355z',
                114:'-702x-157y-347z',
                115:'-72x-156y-781z',
                116:'-75x-272y-748z',
                117:'-7x-117y-791z',
                118:'-82x-537y-586z',
                119:'-84x-159y-779z',
                120:'-90x-615y-502z',
                121:'-91x-275y-745z',
                122:'-96x-161y-777z'}
#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire800eight4xi" usage = "target function for charge800eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire800eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE800EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE800EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE800EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE800EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE800EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight8004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE800EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE800EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE800EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight8004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight8004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE800EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE800EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE800EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire800eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  